﻿@page "/stadiums/create"
@page "/stadiums/edit/{Id:int}"

@using Models.StadiumData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject IStadiumRepository StadiumRepository

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Stadium</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@StadiumModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="StadiumModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => StadiumModel.Name" />
                    </div>
                    <div class="form-group">
                        <label>Address</label>
                        <InputText @bind-Value="StadiumModel.Address" class="form-control"></InputText>
                        <ValidationMessage For="() => StadiumModel.Address" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title Stadium </button>
                        <NavLink href="stadiums" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>



@code {

    [Parameter]
    public int? Id { get; set; }
    private StadiumDTO StadiumModel { get; set; } = new StadiumDTO();
    private string Title { get; set; } = "Create";
    protected override async Task OnInitializedAsync()
    {
        if (Id != null)
        {
            //update
            Title = "Update";
            StadiumModel = await StadiumRepository.Get(Id.Value);
        }
        else
        {
            //create
            StadiumModel = new StadiumDTO();
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if stadium is unique
            // --
            // --
            if (StadiumModel.Id != 0 && Title == "Update")
            {
                //update
                var updateStadium = await StadiumRepository.Update(StadiumModel, StadiumModel.Id);
                await JsRuntime.ToastrSuccess("Stadium updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/stadiums", true);

            }
            else
            {
                //create
                var createdResult = await StadiumRepository.Create(StadiumModel);

                await JsRuntime.ToastrSuccess("Stadium created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/stadiums", true);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}
